<?

require( "header.inc" );
head( $_INI[ "sitename" ] . " // Upload Torrent" );

if( $bttrack_db = sql_connect() )
{
	$tracker_url = "http://" . $_SERVER[ "HTTP_HOST" ] . dirname( $_SERVER[ "PHP_SELF" ] );
	if( $tracker_url[ strlen( $tracker_url ) - 1 ] == "/" )
		$tracker_url .= "announce";
	else
		$tracker_url .= "/announce";
	
	echo "<p>Upload a file that uses <a href=\"" . $tracker_url . "\">" . $tracker_url . "</a> as the announce URL.<br />Those are the only files that will be accepted.</p>";

	echo <<<TEXT
<p>
<form enctype="multipart/form-data" action="upload.php" method="post">
Upload a file<br />
<input type="file" name="tfile" /><br />
Associate a password (so you can delete the .torrent later)<br />
<input type="password" name="password" /><br />
Put the referer to which you want to limit the torrent download.<br />
If left blank, anyone can download the torrent and use the tracker.<br />
If you don't know what this is, leave it blank.<br />
<input type="text" name="referer" size="50" /><br />
<input type="submit" value="Upload" />
</form>
</p>

TEXT;

	/* if a file was uploaded, check the validity */
	if( isset( $_FILES[ "tfile" ] ) && is_uploaded_file( $_FILES[ "tfile" ][ "tmp_name" ] ) )
	{
		$keepfile = 0;
		$tmp_name = $_FILES[ "tfile" ][ "tmp_name" ];

		/* check that a password was associated with the file */
		if( isset( $_POST[ "password" ] ) && strlen( $_POST[ "password" ] ) )
		{
			$password = $_POST[ "password" ];

			/* check that the file is a bEncoded dictionary */
			if( $tinfo = read_file( $tmp_name ) )
			{
				echo "<p>Uploaded file is a valid bEncoded dictionary.</p>\n";

				/* check the announce URL for the torrent file */
				if( !strcasecmp( $tinfo[ "announce" ] , $tracker_url ) )
				{
					echo "<p>Uploaded file is using &quot;" . $tinfo[ "announce" ] . "&quot; as its announce URL.</p>\n";

					/* calculate info hash */
					$mysql_info_hash = mysql_escape_string( $info_hash = sha1( bencode( $tinfo[ "info" ] ) ) );

					/* check for info hash in the database */
					if( mysql_result( $result = mysql_query( "SELECT COUNT( info_hash ) FROM files WHERE info_hash = '" . $mysql_info_hash . "'" , $bttrack_db ) , 0 ) )
						echo "<p>A file with that info_hash already exists.</p>\n";
					else /* unique name and hash */
						$keepfile = 1;
				}
				else
					echo "<p>Uploaded file is using &quot;" . $tinfo[ "announce" ] . "&quot;, not &quot;" . $tracker_url . "&quot; as its announce URL.</p>\n";
			}
			else
				echo "<p>Uploaded file is not a valid bEncoded dictionary.</p>\n";
		}
		else
			echo "<p>You must associate a password with an uploaded file.</p>\n";

		if( $keepfile )
		{
			/* file passed all checks; copy it to upload_dir */

			copy( $tmp_name , $_INI[ "upload_dir" ] . $info_hash );

			$referer = trim( $_POST[ "referer" ] );

			/* check whether torrent is for just one file or for 
			multiple files and calculate total size */

			if( isset( $tinfo[ "info" ][ "length" ] ) ) /* one */
				$size = $tinfo[ "info" ][ "length" ];
			else
			{
				/* multiple */
				$size = 0;
				foreach( $tinfo[ "info" ][ "files" ] as $one_file ) 
					$size += $one_file[ "length" ];
			}

			/* add the torrent to the database */

			if( mysql_query( "INSERT INTO files ( info_hash , uploaded , size , password , referer , last_seeded ) VALUES ( '" . $mysql_info_hash . "' , NOW() , " . mysql_escape_string( $size ) . " , '" . mysql_escape_string( md5( $password ) ) . "' , '" . mysql_escape_string( preg_quote( $referer , "/" ) ) . "' , NOW() )" , $bttrack_db ) )
				echo "<p>Successfully uploaded " . $info_hash . ".</p>\n";
			else
				echo "<p>There was a problem adding the uploaded file to the files database.</p>\n";

			/* add the uploader's IP to the allowed table */

			if( strlen( $referer ) )
			{
				echo "<p>This file will only be downloaded by requests from &quot;" . $referer . "&quot;.</p>\n";

				if( ( $uploader_ip = $_SERVER[ "REMOTE_ADDR" ] ) != "0.0.0.0" )
				{
					if( mysql_query( "INSERT INTO allowed ( info_hash , ip ) VALUES ( '" . $mysql_info_hash . "' , '" . mysql_escape_string( $uploader_ip) . "' )" , $bttrack_db ) )
					{
						echo "<p>Successfully added " . $uploader_ip . " to the list of allowed IPs for this torrent.<br>\n";
						echo "<a href=\"download.php?info_hash=" . $info_hash . "\">This</a> is the link to put at the proper URL.</p>\n";
					}
					else
						echo "<p>There was a problem adding " . $uploader_ip . " to the list of allowed IPs for this torrent; get your IP manually added.</p>\n";
				}
				else
					echo "<p>0.0.0.0 is not a valid IP; get your IP manually added to the list of allowed IPs.</p>\n";
			}
		}
		else
			echo "<p>Upload denied.</p>\n";
	}
	mysql_close( $bttrack_db );
}
else
	echo "<p>There was a problem connecting to the database.</p>\n";

foot();

?>